program opsiscriptstarter;

{$mode objfpc}{$H+}
//{$apptype console}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  //Interfaces, // this includes the LCL widgetset
  Classes,
  SysUtils,
  superobject,
  synacode,
  oslog,
  oswebservice,
  CustApp ,
  process,
  blowfish,
  DCPblowfish,
  DCPcrypt2,
  DCPblockciphers,
  inifiles;


const
  SW_HIDE = 0;
  opsiclientdconf = '/etc/opsi-client-agent/opsiclientd.conf' ;
  opsiscriptbin = '/usr/bin/opsi-script';
  opsiscriptnoguibin = '/usr/bin/opsi-script-nogui';
  opsiclientdlog = 'opsiclientd.log';


type

  { Topsiscriptstarter }

  Topsiscriptstarter = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
  end;

{ Topsiscriptstarter }
bytearray = array[0..255] of byte;

var
  optionlist : TStringlist;
  myexitcode, myloglevel : integer;
  myclientid, myhostkey, myerror, myservice_url : string;
  INI:TINIFile;
  //opsidata : TOpsi4Data;
  logfilename : string;
  myuser, myencryptedpass, mypass,myshare, mydepot, mymountpoint : string;
  mountresult : dword;
  nogui : boolean;

function RunCommandAndCaptureOut
  (cmd: string; catchOut: boolean; var outlines: TStringList;
  var report: string; showcmd: integer; var ExitCode: longint): boolean;
const
  ReadBufferSize = 2048;

var
  //myStringlist : TStringlist;
  S: TStringList;
  M: TMemoryStream;
  FpcProcess: TProcess;
  n: longint;
  BytesRead: longint;

begin
  Result := True;
  try
    try
      M := TMemoryStream.Create;
      BytesRead := 0;
      FpcProcess := process.TProcess.Create(nil);
      FpcProcess.CommandLine := cmd;
      FpcProcess.Options := [poUsePipes, poStderrToOutput];
      FpcProcess.ShowWindow := swoMinimize;
      FpcProcess.Execute;
      //Logdatei.DependentAdd('RunCommandAndCaptureOut: started: ' + cmd, LLdebug2);
      while FpcProcess.Running do
      begin
        // stellt sicher, dass wir Platz haben
        M.SetSize(BytesRead + ReadBufferSize);

        // versuche, es zu lesen
        if FpcProcess.Output.NumBytesAvailable > 0 then
        begin
          n := FpcProcess.Output.Read((M.Memory + BytesRead)^, ReadBufferSize);
          //Logdatei.DependentAdd('RunCommandAndCaptureOut: read: ' +
          //  IntToStr(n) + ' bytes', LLdebug2);
          if n > 0 then
          begin
            Inc(BytesRead, n);
            //Logdatei.DependentAdd('RunCommandAndCaptureOut: read: ' +
            // IntToStr(n) + ' bytes', LLdebug2);
            //Write('.')
          end;
        end
        else
        begin
          // keine Daten, warte 100 ms
          //Logdatei.DependentAdd('RunCommandAndCaptureOut: no data - waiting....',
          // LLdebug2);
          Sleep(100);
        end;
      end;
      exitCode := FpcProcess.ExitStatus;
      // lese den letzten Teil
      repeat
        // stellt sicher, dass wir Platz haben
        M.SetSize(BytesRead + ReadBufferSize);
        if FpcProcess.Output.NumBytesAvailable > 0 then
        begin
          // versuche es zu lesen
          n := FpcProcess.Output.Read((M.Memory + BytesRead)^, ReadBufferSize);
          if n > 0 then
          begin
            Inc(BytesRead, n);
            //Logdatei.DependentAdd('RunCommandAndCaptureOut: read: ' +
            //IntToStr(n) + ' bytes', LLdebug2);
            //Write('.');
          end;
        end
        else
          n := 0;
      until n <= 0;
      //if BytesRead > 0 then WriteLn;
      M.SetSize(BytesRead);
      //Logdatei.DependentAdd('RunCommandAndCaptureOut: -- executed --', LLdebug2);
      //WriteLn('-- executed --');

      S := TStringList.Create;
      S.LoadFromStream(M);
      //Logdatei.DependentAdd('RunCommandAndCaptureOut: -- linecount = ' +
      //  IntToStr(S.Count), LLdebug2);
      //WriteLn('-- linecount = ', S.Count, ' --');
      for n := 0 to S.Count - 1 do
      begin
        //WriteLn('| ', S[n]);
        outlines.Add(S[n]);
      end;
      //WriteLn('-- end --');
      LogDatei.DependentAdd('ExitCode ' + IntToStr(exitCode), LLInfo);
    except
      on e: Exception do
      begin
        LogDatei.DependentAdd('Exception in RunCommandAndCaptureOut: ' +
          e.message, LLError);
        Result := False;
      end;
    end;
  finally
    S.Free;
    FpcProcess.Free;
    M.Free;
  end;
end;

function mountSmbShare(mymountpoint, myshare, myuser, mypass: string) : integer;
var
  cmd, report: string;
  outlines: TStringlist;
  ExitCode: longint;
  i: integer;
begin
  outlines := TStringList.Create;
  Result := 0;
  //{$IFDEF CPU64}
  cmd := '/bin/bash -c "/sbin/mount.cifs ' + myshare+' '+mymountpoint+' -o ro,user='+myuser+',pass='+mypass+'"';
  //{$ELSE}
  //cmd := '/bin/bash -c "/sbin/mount.smbfs ' + myshare+' '+mymountpoint+' -o ro,user='+myuser+',pass='+mypass+'"';
  //{$ENDIF}
  LogDatei.DependentAdd('calling: '+cmd,LLNotice);
  if not RunCommandAndCaptureOut(cmd, True, outlines, report,
    SW_HIDE, ExitCode) then
  begin
    LogDatei.log('Error: ' + Report + 'Exitcode: ' + IntToStr(ExitCode), LLError);
    Result := -1;
  end
  else
  begin
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel + 6;
    LogDatei.log('', LLDebug);
    LogDatei.log('output:', LLDebug);
    LogDatei.log('--------------', LLDebug);
    for i := 0 to outlines.Count - 1 do
    begin
      LogDatei.log(outlines.strings[i], LLDebug);
    end;
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel - 6;
    LogDatei.log('', LLDebug);
  end;
  outlines.Free;
end;

function umount(mymountpoint : string) : integer;
var
  cmd, report: string;
  outlines: TStringlist;
  ExitCode: longint;
  i: integer;
begin
  outlines := TStringList.Create;
  Result := 0;
  cmd := '/bin/bash -c "/bin/umount ' +mymountpoint+'"';
  LogDatei.DependentAdd('calling: '+cmd,LLNotice);
  if not RunCommandAndCaptureOut(cmd, True, outlines, report,
    SW_HIDE, ExitCode) then
  begin
    LogDatei.log('Error: ' + Report + 'Exitcode: ' + IntToStr(ExitCode), LLError);
    Result := -1;
  end
  else
  begin
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel + 6;
    LogDatei.log('', LLDebug);
    LogDatei.log('output:', LLDebug);
    LogDatei.log('--------------', LLDebug);
    for i := 0 to outlines.Count - 1 do
    begin
      LogDatei.log(outlines.strings[i], LLDebug);
    end;
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel - 6;
    LogDatei.log('', LLDebug);
  end;
  outlines.Free;
end;


function startopsiscript : integer;
var
  cmd, report: string;
  outlines: TStringlist;
  ExitCode: longint;
  i: integer;
begin
  outlines := TStringList.Create;
  Result := 0;
  if nogui then
  begin
    cmd := '/bin/bash -c " '+opsiscriptnoguibin + ' -opsiservice '+ myservice_url
                         +' -clientid '+ myclientid
                         +' -username '+ myclientid
                         +' -password ' + myhostkey+' &> /dev/tty1"';
  end
  else
  begin
    cmd := '/bin/bash -c " export DISPLAY=:0 ; '+opsiscriptbin + ' -opsiservice '+ myservice_url
                         +' -clientid '+ myclientid
                         +' -username '+ myclientid
                         +' -password ' + myhostkey+'"';
  end;
  LogDatei.DependentAdd('calling: '+cmd,LLNotice);
  if not RunCommandAndCaptureOut(cmd, True, outlines, report,
    SW_HIDE, ExitCode) then
  begin
    LogDatei.log('Error: ' + Report + 'Exitcode: ' + IntToStr(ExitCode), LLError);
    Result := -1;
  end
  else
  begin
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel + 6;
    LogDatei.log('', LLDebug);
    LogDatei.log('output:', LLDebug);
    LogDatei.log('--------------', LLDebug);
    for i := 0 to outlines.Count - 1 do
    begin
      LogDatei.log(outlines.strings[i], LLDebug);
    end;
    LogDatei.LogSIndentLevel := LogDatei.LogSIndentLevel - 6;
    LogDatei.log('', LLDebug);
  end;
  outlines.Free;
end;


  procedure transformHex
   (const hexstring : String;
    var hexarray : bytearray);
var
   section : String;
   thesize : integer;
   onehex : string;
   i: integer;
 begin
   theSize := length (hexstring) div 2;
   section := hexstring;
   for i:=0 to theSize -1 do
   begin
    onehex := copy(section,1,2);
    HexToBin(Pchar(onehex),@hexarray[i],1);
    section := copy(section,3,length(section));
   end;
 end;

function decrypt(hexkey, hexpass : String) : String;
Var
 passByte, keyByte : bytearray;
 passByteDecry : bytearray;
 passSize : Integer;
 keySize : Integer;
 i: integer;
 Cipher: TDCP_blowfish;
begin
 transformHex (hexkey, keyByte);
 transformHex (hexpass, passByte);

 passSize := length (hexpass) div 2;
 keySize := length (hexkey) div 2;

 //DCP_blowfish1.Init(keyByte,keySize*8,PChar('OPSI1234'));
 //DCP_blowfish1.Decrypt(passByte,passByteDecry,passSize);

  Cipher:= TDCP_blowfish.Create(nil);
  Cipher.Init(keyByte,keySize*8,PChar('OPSI1234')); // remember key size is in BITS

  Cipher.DecryptCBC(passByte,passByteDecry,passSize);
  Cipher.Burn;
  Cipher.Free;

 result := '';
 for i :=0 to passSize - 1 do
  result := result + char (passByteDecry [i])
end;


function DecryptBlowfish(const myencrypted,mykey: string): string;
var
Cipher: TDCP_blowfish;
Key: array[0..15] of byte; // key can be any size upto 448bits with blowfish (56bytes)
//Buffer: array[0..127] of byte; // buffer can be any size
s: string;
i : integer;
begin
  //Cipher.Reset;
  //Cipher.DecryptCBC(Buffer,Buffer,Sizeof(Buffer));
  s:= myencrypted;
  for i := 0 to 15 do
  begin
    key[i] := strtoint('$'+mykey[i*2+1]+mykey[i*2+2]);
  end;
  Cipher:= TDCP_blowfish.Create(nil);
  Cipher.Init(Key,Sizeof(Key)*8,nil); // remember key size is in BITS

  Cipher.DecryptCBC(s[1],s[1],Length(s));
  Cipher.Burn;
  Cipher.Free;
  result := s;
end;


  procedure readconf;
  var
    myini : TInifile;
  begin
    myini := TIniFile.Create(opsiclientdconf);
    myservice_url := myini.ReadString('config_service','url','');
    myclientid := myini.ReadString('global','host_id','');
    myhostkey := myini.ReadString('global','opsi_host_key','');
    myloglevel := myini.ReadInteger('global','log_level',5);
    myini.Free;
  end;

  function MyOpsiMethodCall(const method: string; parameters: array of string) : string;
  var
    omc: TOpsiMethodCall;
    errorOccured: boolean;
    resultstring : string;
  begin
    result := '';
    try
      //if param = '' then
        omc := TOpsiMethodCall.Create(method,parameters);
      //else
      //  omc := TOpsiMethodCall.Create(method,[param]);
      resultstring := opsidata.checkAndRetrieve(omc,errorOccured);
      result := resultstring;
    except
      //LogDatei.DependentAdd('Exception calling method: '+method+'  - with param: '+param, LLerror);
      LogDatei.DependentAdd('Exception calling method: '+method, LLerror);
    end;
  end;

function MyOpsiMethodCall2(const method: string; parameters: array of string) : string;
  var
    omc: TOpsiMethodCall;
    errorOccured: boolean;
    resultstring : string;
    resultstringlist : Tstringlist;
    i : integer;
  begin
    try
      //if param = '' then
        omc := TOpsiMethodCall.Create(method,parameters);
      //else
      //  omc := TOpsiMethodCall.Create(method,[param]);
      //resultstring :=  opsidata.checkAndRetrieveString(omc,errorOccured);
      resultstringlist := TStringlist.Create;
      resultstringlist := opsidata.checkAndRetrieveList(omc,errorOccured);
      for i := 0 to resultstringlist.Count-1 do
         result := resultstringlist[i];

    except
      //LogDatei.DependentAdd('Exception calling method: '+method+'  - with param: '+param, LLerror);
      LogDatei.DependentAdd('Exception calling method: '+method, LLerror);
    end;
  end;

  function initLogging(const clientname : string) : boolean;
  begin
    result := true;
    logdatei := TLogInfo.Create;
    logfilename := opsiclientdlog;
    oslog.CreateTheLogfile(logfilename,false);
    logdatei.LogLevel:=myloglevel;
  end;


function initConnection (const seconds : integer): boolean;
var
  networkup, timeout : boolean;
  myseconds : integer;
begin
  result := false;
  networkup := false;
  timeout := false;
  myseconds := seconds;
  LogDatei.DependentAdd('service_url='+myservice_url,LLDebug2);
  LogDatei.DependentAdd('service_pass='+myhostkey,LLDebug2);
  LogDatei.DependentAdd('clientid='+myclientid,LLDebug2);
  opsidata := TOpsi4Data.create;
  LogDatei.DependentAdd('opsidata created',LLDebug2);
  opsidata.setActualClient(myclientid);
  opsidata.initOpsiConf(myservice_url, myclientid, myhostkey);
  LogDatei.DependentAdd('opsidata initialized',LLDebug2);
  repeat
    try
      if opsidata.isConnected then networkup:= true
      else
      begin
        LogDatei.DependentAdd('opsidata not connected - retry',LLInfo);
        writeln('opsidata not connected - retry');
        myseconds := myseconds -1;
        Sleep(1000);
      end;
    except
      LogDatei.DependentAdd('opsidata not connected - retry',LLInfo);
      writeln('opsidata not connected - retry');
      myseconds := myseconds -1;
      Sleep(1000);
    end;
    if myseconds = 0 then timeout := true;
  until networkup or timeout;
  if networkup then
  begin
    LogDatei.DependentAdd('opsidata connected',LLInfo);
    writeln('opsidata connected');
    result := true;
  end
  else
  begin
    LogDatei.DependentAdd('init connection failed (timeout after '+ IntToStr(seconds) + ' seconds/retries.',LLError);
    writeln('init connection failed (timeout after '+ IntToStr(seconds) + ' seconds/retries.');
  end;
end;


procedure Topsiscriptstarter.DoRun;
var
  ErrorMsg: String;
  parameters: array of string;
  //parameterlist : TStringlist;
  resultstring : string;
  actionlist : TStringlist;
  foundActionRequest : boolean;
  i : integer;
begin
  myexitcode := 0;
  myerror := '';
  myDepot := '';
  myuser := 'pcpatch';
  myshare := 'opsi_depot';
  mymountpoint := '/mnt';
  nogui := false;

  optionlist := TStringlist.Create;
  optionlist.Append('help');
  optionlist.Append('nogui');
  // quick check parameters
  ErrorMsg:= CheckOptions('',optionlist);
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Terminate;
    Exit;
  end;



  // parse parameters
  if HasOption('h','help') then begin
    WriteHelp;
    Terminate;
    Exit;
  end;
  if HasOption('nogui') then begin
    nogui := true;
  end;

  readconf;
  initlogging(myclientid);




  writeln('clientid='+myclientid);
  writeln('service_url='+myservice_url);
  writeln('service_user='+myclientid);
  //writeln('host_key=',myhostkey);
  logdatei.AddToConfidentials(myhostkey);
  writeln('log_level=',myloglevel);

  if initConnection(30) then
  begin
    writeln('init done');
    LogDatei.DependentAdd('init done',LLNotice);
    LogDatei.DependentAdd('Starting opsiclientd part:',LLNotice);
    foundActionRequest := false;
    actionlist := opsidata.getMapOfProductActionRequests;
    if actionlist.Count > 0 then
      for i := 0 to actionlist.Count-1 do
      begin
        LogDatei.DependentAdd('action'+inttostr(i)+': '+actionlist.Strings[i],LLNotice);
        if not (actionlist.ValueFromIndex[i] = 'none') then foundActionRequest := true;
      end;
    if not foundActionRequest then
    begin
      LogDatei.DependentAdd('No action requests - nothing to do',LLNotice);
      writeln('No action requests - nothing to do');
    end
    else
    begin
      LogDatei.DependentAdd('Action requests found',LLNotice);
      writeln('Action requests found');
      opsidata.setActualClient(myclientid);
      mydepot := opsidata.depotId;
      writeln('depotId=',mydepot);
      //resultstring := MyOpsiMethodCall2('configState_getClientToDepotserver', ['[]','['+myclientid+']','True','["acroread", "config-win-base"]']);
      //myDepot := SO(resultstring).S['depotId'];
      resultstring := MyOpsiMethodCall('user_getCredentials', ['pcpatch',myclientid]);
      myencryptedpass := SO(resultstring).O['result'].S['password'];
      mypass := decrypt(myhostkey,myencryptedpass);
      //writeln('mypass=',mypass);
      resultstring := MyOpsiMethodCall('host_getObjects', ['','{"type":"OpsiDepotserver","id":["'+myDepot+'"]}']);
      myshare := SO(resultstring).S['result'];
      myshare := SO(resultstring).O['result'].AsArray.O[0].S['depotRemoteUrl'];
      myshare := copy(myshare,5,length(myshare));
      writeln('myshare=',myshare);
      logdatei.AddToConfidentials(mypass);
      errorcode := mountSmbShare(mymountpoint, myshare, myuser, mypass);
      if errorcode > 0 then
      begin
        // error
        LogDatei.DependentAdd('Failed to mount '+myshare+' to '+mymountpoint+' Error code: '+inttostr(errorcode),LLError);
        exit;
      end
      else
      begin
        writeln('share mounted - starting action processor...');
        startopsiscript;
        writeln('action processor finished');
        umount(mymountpoint);
        writeln('share unmounted');
      end;
    end;
    opsidata.sendLog('clientconnect');
  end
  else
  begin
    //writeln('init failed');
    LogDatei.DependentAdd('init failed',LLError);
  end;
  // stop program loop
  Terminate;
end;

constructor Topsiscriptstarter.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor Topsiscriptstarter.Destroy;
begin
  inherited Destroy;
end;

procedure Topsiscriptstarter.WriteHelp;
var
  filename : string;
begin
  filename := ExtractFileName(paramstr(0));
  writeln(paramstr(0));
  writeln(filename);
  writeln(myerror);
  writeln(Title);
  writeln('Usage:');
  writeln(filename+ ' --help');
  writeln('Options:');
  writeln(' --help -> write this help and exit');
  writeln(' --nogui -> starts opsi-script-nogui instead of opsi-script');
  Terminate;
  halt(-1);
  Exit;
end;

var
  Application: Topsiscriptstarter;

{$R *.res}

begin
  Application:=Topsiscriptstarter.Create(nil);
  Application.Title:='opsi-script-starter';
  Application.Run;
  Application.Free;
end.

